// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2010                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

// -----------------------------------------------------------------
// FVIL Sample Program
// p^\_CAO
//
// 쐬 : N.Moriguchi
//
//  : 2010/10/05 
//
// -----------------------------------------------------------------
namespace GS2
{
    public partial class Form_PTNDISPLAY : Form
    {
        //p^\NX
        private FVIL.Data.CFviPattern m_pattern_org;
        private FVIL.Data.CFviPattern m_pattern_temp;

        public Form_PTNDISPLAY()
        {
            InitializeComponent();
        }

        /// <summary>
        /// tH[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^\tH[̏B
        /// </remarks>
        private void Form_PTNDISPLAY_Load(object sender, EventArgs e)
        {
            //p^{R{{bNX
            comboBoxPatternMag.Items.Clear();
            comboBoxPatternMag.Items.Add("1");
            comboBoxPatternMag.Items.Add("2");
            comboBoxPatternMag.Items.Add("4");
            comboBoxPatternMag.SelectedIndex = 0;

            //J[\TCYR{{bNX
            comboBoxCursorSize.Items.Clear();
            comboBoxCursorSize.Items.Add("1");
            comboBoxCursorSize.Items.Add("3");
            comboBoxCursorSize.Items.Add("5");
            comboBoxCursorSize.Items.Add("7");
            comboBoxCursorSize.Items.Add("11");
            comboBoxCursorSize.SelectedIndex = 0;

            //p^摜̕
            m_pattern_temp = (FVIL.Data.CFviPattern)m_pattern_org.Clone();
            // p^\
            cFviImageView1.Image = m_pattern_temp;
            //ĕ`
            cFviImageView1.Refresh();
        }

        /// <summary>
        /// p^IuWFNg̊i[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// CtH[̃p^̎擾B
        /// </remarks>
        public void Set_pattern(FVIL.Data.CFviPattern pattern)
        {
            m_pattern_org = pattern;
        }

        /// <summary>
        /// p^\ɕύX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^\[hp\ύXB
        /// </remarks>
        public void Mode_Pattern()
        {
            button_OK.Visible = false;
            button_Cancel.Text = "߂";
            groupBoxPenForm.Visible = false;
        }

        /// <summary>
        /// }XNݒɕύX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// }XNݒ胂[hp\ύXB
        /// </remarks>
        public void Mode_Mask()
        {
            button_OK.Visible = true;
            button_Cancel.Text = "Cancel";
            groupBoxPenForm.Visible = true;

            cFviImageView1.Display.MaskEnable = true;
            cFviImageView1.Display.OverlayPatternModify.Active = true;
            cFviImageView1.Display.OverlayPatternModify.MaskBit = FVIL.Data.Pattern.MaskBit.MASK;
        }

        /// <summary>
        /// yWI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\yɕύXB
        /// </remarks>
        private void radioButtonModePen_CheckedChanged(object sender, EventArgs e)
        {
            cFviImageView1.Display.OverlayPatternModify.MaskCursorMode = FVIL.GDI.MaskCursorMode.Write;
        }

        /// <summary>
        /// SWI{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\SɕύXB
        /// </remarks>
        private void radioButtonModeEraser_CheckedChanged(object sender, EventArgs e)
        {
            cFviImageView1.Display.OverlayPatternModify.MaskCursorMode = FVIL.GDI.MaskCursorMode.Erase;
        }

        /// <summary>
        /// p^\{R{{bNX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^摜̕\{ύXB
        /// </remarks>
        private void comboBoxPatternMag_SelectedIndexChanged(object sender, EventArgs e)
        {
            //\{̐ݒ
            switch (comboBoxPatternMag.SelectedIndex)
            {
                case 0:
                    cFviImageView1.Display.Magnification = 1.0;
                    break;
                case 1:
                    cFviImageView1.Display.Magnification = 2.0;
                    break;
                case 2:
                    cFviImageView1.Display.Magnification = 4.0;
                    break;
                default:
                    cFviImageView1.Display.Magnification = 1.0;
                    break;
            }
            //ĕ`
            cFviImageView1.Refresh();
        }

        /// <summary>
        /// CursorSizeR{{bNX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// J[\TCYύXB
        /// </remarks>
        private void comboBoxCursorSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBoxCursorSize.SelectedIndex)
            {
                case 0:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(1, 1);
                    break;
                case 1:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(3, 3);
                    break;
                case 2:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(5, 5);
                    break;
                case 3:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(7, 7);
                    break;
                case 4:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(11, 11);
                    break;
                default:
                    cFviImageView1.Display.OverlayPatternModify.MaskCursorSize = new Size(1, 1);
                    break;
            }
        }

        /// <summary>
        /// OK{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// CtH[̃p^f[^XVB
        /// </remarks>
        private void button_OK_Click(object sender, EventArgs e)
        {
            //p^f[^XV
            m_pattern_org.CopyFrom(m_pattern_temp);
            Close();
        }

        /// <summary>
        /// LZ{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// p^\tH[ł̐ݒjB
        /// </remarks>
        private void button_Cancel_Click(object sender, EventArgs e)
        {
            Close();
        }
    }

}